(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("normalized-db", [], factory);
	else if(typeof exports === 'object')
		exports["normalized-db"] = factory();
	else
		root["normalized-db"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
function isNull(object) {
    return typeof object === 'undefined' || object === null;
}
exports.isNull = isNull;
function isObject(object) {
    return !isNull(object) && typeof object === 'object';
}
exports.isObject = isObject;


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
function deepClone(object) {
    var ctor = object ? object.constructor : null;
    if (object === null || typeof object !== 'object' || ctor === ArrayBuffer || ctor === Blob || ctor === File) {
        return object;
    }
    if (ctor === Date || ctor === RegExp || ctor === Function || ctor === JSON ||
        ctor === String || ctor === Number || ctor === Boolean ||
        ctor === Set || ctor === Map || ctor === WeakMap || ctor === WeakSet) {
        return new ctor(object);
    }
    var result = new ctor();
    Object.keys(object)
        .forEach(function (key) { return result[key] = deepClone(object[key]); });
    return result;
}
exports.deepClone = deepClone;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var deep_clone_1 = __webpack_require__(1);
var object_1 = __webpack_require__(0);
var Schema = (function () {
    function Schema(userConfig) {
        var _this = this;
        this.config = {};
        this.userConfig = deep_clone_1.deepClone(userConfig);
        this.initDefaults();
        var keys = Object.keys(this.userConfig);
        keys.filter(function (type) { return !type.startsWith('_'); })
            .forEach(function (type) { return _this.config[type] = _this.expandSchemaForType(type); });
    }
    Schema.prototype.hasType = function (type) {
        return type in this.config;
    };
    Schema.prototype.getTypes = function () {
        return Object.keys(this.config);
    };
    Schema.prototype.getConfig = function (type) {
        if (this.hasType(type)) {
            return this.config[type];
        }
        else {
            this.onNoSchemaFound(type);
        }
    };
    Schema.prototype.getTargetItem = function (type, field) {
        var config = this.getConfig(type);
        if (field in config.targets) {
            return config.targets[field];
        }
        else {
            return null;
        }
    };
    Schema.prototype.getTargetConfig = function (type, field) {
        var config = this.getConfig(type);
        if (field in config.targets) {
            return this.getConfig(config.targets[field].type);
        }
        else {
            this.onNoSchemaFound(type + '.' + field);
        }
    };
    Schema.prototype.toString = function () {
        return JSON.stringify(this.config);
    };
    Schema.prototype.initDefaults = function () {
        if (Schema.TYPE_DEFAULTS in this.userConfig) {
            if (typeof this.userConfig._defaults !== 'object') {
                throw new Error('Defaults must be an instance of `IStoreConfig`');
            }
            this.userConfig._defaults.autoKey = this.userConfig._defaults.autoKey === true;
            if (!('targets' in this.userConfig._defaults)) {
                this.userConfig._defaults.targets = {};
            }
        }
        else {
            this.userConfig._defaults = {
                autoKey: false,
                targets: {}
            };
        }
    };
    Schema.prototype.expandSchemaForType = function (type) {
        if (type in this.userConfig && this.userConfig[type] !== false) {
            var typeSchema = this.userConfig[type];
            if (type === Schema.TYPE_DEFAULTS) {
                var defaults = this.userConfig[Schema.TYPE_DEFAULTS];
                if (defaults.targets) {
                    defaults.targets = this.expandTargets(defaults.targets);
                }
                return deep_clone_1.deepClone(defaults);
            }
            else if (typeSchema === true) {
                return Object.assign(this.expandSchemaForType(Schema.TYPE_DEFAULTS), { type: type });
            }
            else if (typeof typeSchema === 'string') {
                return Object.assign(deep_clone_1.deepClone(this.expandSchemaForType(typeSchema)), { type: type });
            }
            else if (typeof typeSchema === 'object') {
                var parentSchema = this.expandSchemaForType(typeSchema.parent || Schema.TYPE_DEFAULTS);
                return this.mergeConfigs(type, typeSchema, parentSchema);
            }
            else {
                throw new Error('Schema for type \'' + type + '\' is invalid');
            }
        }
        else {
            this.onNoSchemaFound(type);
        }
    };
    Schema.prototype.mergeConfigs = function (type, typeConfig, parent) {
        var targets = Object.assign(parent.targets, typeConfig.targets);
        var autoKey = object_1.isNull(typeConfig.autoKey || null) ? parent.autoKey : typeConfig.autoKey;
        var result = {
            type: type,
            key: typeConfig.key || parent.key,
            autoKey: autoKey || false,
            targets: this.expandTargets(targets)
        };
        return result;
    };
    Schema.prototype.expandTargets = function (targetConfig) {
        var result = {};
        Object.keys(targetConfig).forEach(function (field) {
            var item = targetConfig[field];
            result[field] = typeof item === 'string'
                ? { type: item }
                : item;
        });
        return result;
    };
    Schema.prototype.onNoSchemaFound = function (type) {
        throw new Error('No config found for type \'' + type + '\'');
    };
    Schema.TYPE_DEFAULTS = '_defaults';
    return Schema;
}());
exports.Schema = Schema;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var object_1 = __webpack_require__(0);
var StoreBuilder = (function () {
    function StoreBuilder(parent, key, autoKey, targets) {
        this.parent = parent;
        this.key = key;
        this.autoKey = autoKey;
        this.targets = targets;
    }
    StoreBuilder.prototype.setKey = function (key) {
        this.key = key;
        return this;
    };
    StoreBuilder.prototype.setAutoKey = function (autoKey) {
        this.autoKey = autoKey;
        return this;
    };
    StoreBuilder.prototype.setParent = function (parent) {
        this.parent = parent;
        return this;
    };
    StoreBuilder.prototype.hasTarget = function (field) {
        return field in this.targets;
    };
    StoreBuilder.prototype.setTarget = function (field, type, cascadeRemoval) {
        if (cascadeRemoval === void 0) { cascadeRemoval = false; }
        var config = { type: type };
        if (cascadeRemoval) {
            config.cascadeRemoval = true;
        }
        if (this.targets) {
            this.targets[field] = config;
        }
        else {
            this.targets = (_a = {}, _a[field] = config, _a);
        }
        return this;
        var _a;
    };
    StoreBuilder.prototype.setArrayTarget = function (field, type, cascadeRemoval) {
        if (cascadeRemoval === void 0) { cascadeRemoval = false; }
        this.setTarget(field, type, cascadeRemoval);
        this.targets[field].isArray = true;
        return this;
    };
    StoreBuilder.prototype.removeTarget = function (field) {
        if (this.hasTarget(field)) {
            delete this.targets[field];
        }
        return this;
    };
    Object.defineProperty(StoreBuilder.prototype, "build", {
        get: function () {
            if (this.hasConfiguration) {
                var result = {};
                if (this.key) {
                    result.key = this.key;
                }
                if (!object_1.isNull(this.autoKey)) {
                    result.autoKey = this.autoKey;
                }
                if (this.parent) {
                    result.parent = this.parent;
                }
                if (this.targets) {
                    result.targets = this.targets;
                }
                return result;
            }
            else if (this.parent) {
                return this.parent;
            }
            else {
                return true;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreBuilder.prototype, "hasConfiguration", {
        get: function () {
            return !object_1.isNull(this.key) || !object_1.isNull(this.autoKey) || this.hasTargets;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreBuilder.prototype, "hasTargets", {
        get: function () {
            return !object_1.isNull(this.targets) && Object.keys(this.targets).length > 0;
        },
        enumerable: true,
        configurable: true
    });
    return StoreBuilder;
}());
exports.StoreBuilder = StoreBuilder;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5);


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(6));
__export(__webpack_require__(11));
__export(__webpack_require__(14));
__export(__webpack_require__(16));


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var invalid_type_error_1 = __webpack_require__(7);
exports.InvalidTypeError = invalid_type_error_1.InvalidTypeError;
var missing_key_error_1 = __webpack_require__(8);
exports.MissingKeyError = missing_key_error_1.MissingKeyError;
var not_found_error_1 = __webpack_require__(9);
exports.NotFoundError = not_found_error_1.NotFoundError;
var type_mismatch_error_1 = __webpack_require__(10);
exports.TypeMismatchError = type_mismatch_error_1.TypeMismatchError;


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidTypeError = (function (_super) {
    __extends(InvalidTypeError, _super);
    function InvalidTypeError(type) {
        return _super.call(this, "Type \"" + type + "\" is not configured") || this;
    }
    return InvalidTypeError;
}(Error));
exports.InvalidTypeError = InvalidTypeError;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var MissingKeyError = (function (_super) {
    __extends(MissingKeyError, _super);
    function MissingKeyError(type, keyField) {
        return _super.call(this, "Key " + keyField + " is missing in object of type " + type) || this;
    }
    return MissingKeyError;
}(Error));
exports.MissingKeyError = MissingKeyError;


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NotFoundError = (function (_super) {
    __extends(NotFoundError, _super);
    function NotFoundError(type, key) {
        return _super.call(this, "Could not find \"" + type + "\" with key \"" + key + "\"") || this;
    }
    return NotFoundError;
}(Error));
exports.NotFoundError = NotFoundError;


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var TypeMismatchError = (function (_super) {
    __extends(TypeMismatchError, _super);
    function TypeMismatchError(parentType, parentField, expectedArray) {
        return _super.call(this, "\"" + parentType + "." + parentField + "\" is expected to be an " + (expectedArray
            ? 'array'
            : 'object') + " but got " + (expectedArray ? 'object' : 'array') + ".") || this;
    }
    return TypeMismatchError;
}(Error));
exports.TypeMismatchError = TypeMismatchError;


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var deep_clone_1 = __webpack_require__(1);
exports.deepClone = deep_clone_1.deepClone;
var object_1 = __webpack_require__(0);
exports.isNull = object_1.isNull;
exports.isObject = object_1.isObject;
var queue_1 = __webpack_require__(12);
exports.Queue = queue_1.Queue;
var refs_1 = __webpack_require__(13);
exports.RefsUtility = refs_1.RefsUtility;


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Queue = (function () {
    function Queue(data) {
        if (data === void 0) { data = []; }
        this.data = data;
    }
    Object.defineProperty(Queue.prototype, "length", {
        get: function () {
            return this.data.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Queue.prototype, "isEmpty", {
        get: function () {
            return this.length === 0;
        },
        enumerable: true,
        configurable: true
    });
    Queue.prototype.enqueue = function (item) {
        this.data.push(item);
    };
    Queue.prototype.dequeue = function () {
        return this.data.shift();
    };
    Queue.prototype.clear = function () {
        this.data.splice(0, this.length);
    };
    return Queue;
}());
exports.Queue = Queue;


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var RefsUtility = (function () {
    function RefsUtility() {
    }
    RefsUtility.has = function (item, type) {
        return '_refs' in item && type in item._refs && item._refs[type].size > 0;
    };
    RefsUtility.hasKey = function (item, type, key) {
        return this.has(item, type) && item._refs[type].has(key);
    };
    RefsUtility.iterator = function (item, type) {
        return this.has(item, type) ? item._refs[type].values() : {
            next: function () {
                return { value: null, done: true };
            }
        };
    };
    RefsUtility.getAll = function (item, type) {
        return this.has(item, type) ? Array.from(item._refs[type]) : [];
    };
    RefsUtility.first = function (item, type) {
        return this.has(item, type) ? (item._refs[type].values().next().value) : null;
    };
    return RefsUtility;
}());
exports.RefsUtility = RefsUtility;


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var depth_1 = __webpack_require__(15);
exports.Depth = depth_1.Depth;


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Depth = (function () {
    function Depth() {
    }
    return Depth;
}());
exports.Depth = Depth;


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = __webpack_require__(2);
exports.Schema = schema_1.Schema;
__export(__webpack_require__(17));


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var schema_builder_1 = __webpack_require__(18);
exports.SchemaBuilder = schema_builder_1.SchemaBuilder;
var store_builder_1 = __webpack_require__(3);
exports.StoreBuilder = store_builder_1.StoreBuilder;


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = __webpack_require__(2);
var store_builder_1 = __webpack_require__(3);
var SchemaBuilder = (function () {
    function SchemaBuilder() {
        this.defaultStore = new store_builder_1.StoreBuilder();
        this.schema = (_a = {}, _a[schema_1.Schema.TYPE_DEFAULTS] = this.defaultStore, _a);
        var _a;
    }
    Object.defineProperty(SchemaBuilder.prototype, "getDefaultStore", {
        get: function () {
            return this.defaultStore;
        },
        enumerable: true,
        configurable: true
    });
    SchemaBuilder.prototype.setDefaultKey = function (key) {
        this.defaultStore.setKey(key);
        return this;
    };
    SchemaBuilder.prototype.setDefaultAutoKey = function (autoKey) {
        this.defaultStore.setAutoKey(autoKey);
        return this;
    };
    SchemaBuilder.prototype.setDefaultTarget = function (field, type, cascadeRemoval) {
        if (cascadeRemoval === void 0) { cascadeRemoval = false; }
        this.defaultStore.setTarget(field, type, cascadeRemoval);
        return this;
    };
    SchemaBuilder.prototype.setDefaultArrayTarget = function (field, type, cascadeRemoval) {
        if (cascadeRemoval === void 0) { cascadeRemoval = false; }
        this.defaultStore.setArrayTarget(field, type, cascadeRemoval);
        return this;
    };
    SchemaBuilder.prototype.hasStore = function (type) {
        return type in this.schema;
    };
    SchemaBuilder.prototype.getStore = function (type) {
        if (this.hasStore(type)) {
            return this.schema[type];
        }
        else {
            throw new Error('No prefix \'' + type + '\' is defined');
        }
    };
    SchemaBuilder.prototype.setStore = function (type, parent) {
        if (parent === void 0) { parent = null; }
        var storeBuilder = new store_builder_1.StoreBuilder(parent);
        this.schema[type] = storeBuilder;
        return storeBuilder;
    };
    SchemaBuilder.prototype.setAbstractStore = function (type, parent) {
        if (parent === void 0) { parent = null; }
        return this.setStore('_' + type, parent);
    };
    SchemaBuilder.prototype.getAbstractStore = function (type) {
        return this.getStore('_' + type);
    };
    SchemaBuilder.prototype.removeStore = function (type) {
        if (this.hasStore(type)) {
            delete this.schema[type];
        }
        return this;
    };
    Object.defineProperty(SchemaBuilder.prototype, "build", {
        get: function () {
            var _this = this;
            return Object.keys(this.schema)
                .filter(function (type) { return _this.schema[type] instanceof store_builder_1.StoreBuilder; })
                .reduce(function (result, type) {
                result[type] = _this.schema[type].build;
                return result;
            }, {});
        },
        enumerable: true,
        configurable: true
    });
    return SchemaBuilder;
}());
exports.SchemaBuilder = SchemaBuilder;


/***/ })
/******/ ]);
});
//# sourceMappingURL=index.js.map