import { ISchemaConfig } from '../model/schema-config-interface';
import { StoreBuilder } from './store-builder';
export declare class SchemaBuilder {
    private readonly defaultStore;
    private readonly schema;
    readonly getDefaultStore: StoreBuilder;
    setDefaultKey(key: string): SchemaBuilder;
    setDefaultAutoKey(autoKey: boolean): SchemaBuilder;
    setDefaultTarget(field: string, type: string, cascadeRemoval?: boolean): SchemaBuilder;
    setDefaultArrayTarget(field: string, type: string, cascadeRemoval?: boolean): SchemaBuilder;
    hasStore(type: string): boolean;
    getStore(type: string): StoreBuilder;
    setStore(type: string, parent?: string): StoreBuilder;
    setAbstractStore(type: string, parent?: string): StoreBuilder;
    getAbstractStore(type: string): StoreBuilder;
    removeStore(type: string): SchemaBuilder;
    readonly build: ISchemaConfig;
}
