import { IStoreConfig } from '../model/store-config-interface';
import { IStoreTargetConfig } from '../model/store-target-config-interface';
export declare class StoreBuilder {
    private parent;
    private key;
    private autoKey;
    private targets;
    constructor(parent?: string, key?: string, autoKey?: boolean, targets?: IStoreTargetConfig);
    setKey(key: string): StoreBuilder;
    setAutoKey(autoKey: boolean): StoreBuilder;
    setParent(parent: string): StoreBuilder;
    hasTarget(field: string): boolean;
    setTarget(field: string, type: string, cascadeRemoval?: boolean): StoreBuilder;
    setArrayTarget(field: string, type: string, cascadeRemoval?: boolean): StoreBuilder;
    removeTarget(field: string): StoreBuilder;
    readonly build: boolean | string | IStoreConfig;
    private readonly hasConfiguration;
    private readonly hasTargets;
}
