import { ISchemaConfig } from './model/schema-config-interface';
import { IStore } from './model/store-interface';
import { IStoreTargetItem } from './model/store-target-item-interface';
import { ISchema } from './schema-interface';
export declare class Schema implements ISchema {
    static readonly TYPE_DEFAULTS: string;
    private readonly config;
    private readonly userConfig;
    constructor(userConfig: ISchemaConfig);
    hasType(type: string): boolean;
    getTypes(): string[];
    getConfig(type: string): IStore;
    getTargetItem(type: string, field: any): IStoreTargetItem;
    getTargetConfig(type: string, field: string): IStore;
    toString(): string;
    private initDefaults();
    private expandSchemaForType(type);
    private mergeConfigs(type, typeConfig, parent);
    private expandTargets(targetConfig);
    private onNoSchemaFound(type);
}
